package kadai1;

import java.sql.*;
import java.text.*;
import java.util.*;
import org.apache.log4j.Logger;

public class Database {

    private static Connection getDatabaseConnection() throws Exception {
        Class.forName("org.hsqldb.jdbcDriver");
        String url = "jdbc:hsqldb:file:c:\\mydb\\kadai\\hsqldb;create=true";
        System.out.println("Connecting to " + url);
        Connection con = DriverManager.getConnection(url, "sa", "");
        System.out.println("Connected");
        return con;
    }

    private static void createTable() throws Exception {
        try {
            Connection con = getDatabaseConnection();

            System.out.println("Create table");
            Statement st = con.createStatement();
            st.executeUpdate(
                "create table userdata (" +
                    "id varchar(9) PRIMARY KEY," +
                    "lastname varchar(32) NOT NULL," +
                    "firstname varchar(32) NOT NULL," +
                    "lastnamekana varchar(64) NOT NULL," +
                    "firstnamekana varchar(64) NOT NULL," +
                    "sex int NOT NULL," +
                    "birthyear int NOT NULL," +
                    "birthmonth int NOT NULL," +
                    "birthdate int NOT NULL," +
                    "mailaddress varchar(255) UNIQUE NOT NULL," +
                    "area int NOT NULL," +
                    "prefecture int NOT NULL," +
                    "schoolname varchar(128)," +
                    "grade int NOT NULL," +
                    "password varchar(12) NOT NULL" +
                ")");
            System.out.println("Created");

            st.close();
            con.close();

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    private static String createId(ModelUserData userdata) throws Exception {
        String result = null;
        String jk = ( (userdata.birthyear >= 3) && (userdata.grade >= 3) )? "J": "K";
        //2B
        String year;
        {
            Calendar cal = Calendar.getInstance();
            SimpleDateFormat sf = new SimpleDateFormat("yy");
            year = sf.format(cal.getTime());
        }
        int serial_num;
        //_ȃAt@xbg啶BiIOZj
        String rand_xx = "";
        {
            Random rand = new Random();
            for (int i=0; i < 2; i++){
                char c = "ABCDEFGHJKLMNPQRSTUVWXY".charAt(rand.nextInt(26-3));
                rand_xx += c;
            }
        }
        try {
            Connection con = getDatabaseConnection();

            Statement st = con.createStatement();
            String querystring = "select count(*) from userdata where id like '" + jk + "%'";
//            System.out.println(querystring);
            ResultSet rs = st.executeQuery(querystring);
            rs.next();
            serial_num = rs.getInt(1) +1;

            con.close();

//TODO:ꖜʂԍȂB
            if (serial_num < 10000) {
                DecimalFormat df = new DecimalFormat("0000");
                result = jk + year + df.format(serial_num) + rand_xx;
            }
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            result = null;
        } catch (SQLException e) {
            e.printStackTrace();
            result = null;
        }
        
//        System.out.println(result);
        return result;
    }

    public static void insertData(ModelUserData userdata) throws Exception {
        createTable();
//TODO:e[ubN͋CɂĂȂB
        String newid = createId(userdata);
        if (newid == null) {
            userdata.errname = "internal";
            userdata.errmessage = "IDԍ͊";
            return;
        }
        try {
            Connection con = getDatabaseConnection();

            System.out.println("Insert data");
            PreparedStatement ps = con.prepareStatement("insert into userdata values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
            int paramcount = 1;
            ps.setString(paramcount++, newid);
            ps.setString(paramcount++, userdata.lastname);
            ps.setString(paramcount++, userdata.firstname);
            ps.setString(paramcount++, userdata.lastnamekana);
            ps.setString(paramcount++, userdata.firstnamekana);
            ps.setInt(paramcount++, userdata.sex);
            ps.setInt(paramcount++, userdata.birthyear);
            ps.setInt(paramcount++, userdata.birthmonth);
            ps.setInt(paramcount++, userdata.birthdate);
            ps.setString(paramcount++, userdata.mailaddress);
            ps.setInt(paramcount++, userdata.area);
            ps.setInt(paramcount++, userdata.prefecture);
            ps.setString(paramcount++, userdata.schoolname);
            ps.setInt(paramcount++, userdata.grade);
            ps.setString(paramcount++, userdata.password);
//            System.out.println(ps.toString());

            int result = ps.executeUpdate();
            System.out.println("Inserted " + result);
            logging(userdata);

            ps.close();
            con.close();

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            userdata.errname = "internal";
            userdata.errmessage = "G[FClassNotFoundException";
        } catch (SQLException e) {
            e.printStackTrace();
            userdata.errname = "internal";
            userdata.errmessage = "G[FSQLException";
        }
    }

    public static void updateData(ModelUserData userdata) throws Exception {
        createTable();
        try {
            Connection con = getDatabaseConnection();

            System.out.println("Update data");
            PreparedStatement ps = con.prepareStatement(
                    "update userdata set " +
                    "lastname=?," +
                    "firstname=?," +
                    "lastnamekana=?," +
                    "firstnamekana=?," +
                    "sex=?," +
                    "birthyear=?," +
                    "birthmonth=?," +
                    "birthdate=?," +
                    "mailaddress=?," +
                    "area=?," +
                    "prefecture=?," +
                    "schoolname=?," +
                    "grade=?," +
                    "password=?" +
                    " where id=?");
            int paramcount = 1;
            ps.setString(paramcount++, userdata.lastname);
            ps.setString(paramcount++, userdata.firstname);
            ps.setString(paramcount++, userdata.lastnamekana);
            ps.setString(paramcount++, userdata.firstnamekana);
            ps.setInt(paramcount++, userdata.sex);
            ps.setInt(paramcount++, userdata.birthyear);
            ps.setInt(paramcount++, userdata.birthmonth);
            ps.setInt(paramcount++, userdata.birthdate);
            ps.setString(paramcount++, userdata.mailaddress);
            ps.setInt(paramcount++, userdata.area);
            ps.setInt(paramcount++, userdata.prefecture);
            ps.setString(paramcount++, userdata.schoolname);
            ps.setInt(paramcount++, userdata.grade);
            ps.setString(paramcount++, userdata.password);
            ps.setString(paramcount++, userdata.id);
//            System.out.println(ps.toString());

            int result = ps.executeUpdate();
            System.out.println("Updated " + result);
            logging(userdata);

            ps.close();
            con.close();

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            userdata.errname = "internal";
            userdata.errmessage = "G[FClassNotFoundException";
        } catch (SQLException e) {
            e.printStackTrace();
            userdata.errname = "internal";
            userdata.errmessage = "G[FSQLException";
        }
    }

    public static ArrayList<ModelUserData> selectData(ModelUserData userdata) throws Exception {
        ArrayList<ModelUserData> result = new ArrayList<ModelUserData>();

        try {
            Connection con = getDatabaseConnection();

            boolean isadd = false;
            String querystring = "select * from userdata where";
            if( !( (userdata.id == null) || userdata.id.isEmpty()) ) {
                querystring += " id like ?";
                isadd = true;
            }
            if(userdata.grade > 1) {
                if(isadd) querystring += " AND";
                querystring += " grade=?";
                isadd = true;
            }
            if( !( (userdata.mailaddress == null) || userdata.mailaddress.isEmpty()) ) {
                if(isadd) querystring += " AND";
                querystring += " mailaddress like ?";
                isadd = true;
            }
            if(userdata.area > 1) {
                if(isadd) querystring += " AND";
                querystring += " area=?";
                isadd = true;
            }
//            System.out.println(querystring);

            int paramcount = 1;
            PreparedStatement ps = con.prepareStatement(querystring);
            if( !( (userdata.id == null) || userdata.id.isEmpty()) ) {
                if (userdata.id.length() >= 9) {
                    // SQLExceptiono
                    // ͎ɕĂ邽߂ł9
                    ps.setString(paramcount, userdata.id);
                } else {
                    ps.setString(paramcount, userdata.id +"%");
                }
                paramcount++;
            }
            if(userdata.grade > 1) {
                ps.setInt(paramcount, userdata.grade);
                paramcount++;
            }
            if( !( (userdata.mailaddress == null) || userdata.mailaddress.isEmpty()) ) {
                ps.setString(paramcount, userdata.mailaddress +"%");
                paramcount++;
            }
            if(userdata.area > 1) {
                ps.setInt(paramcount, userdata.area);
                paramcount++;
            }

//            System.out.println(ps.toString());
            ResultSet rs = ps.executeQuery();
            System.out.println("selected");

            while ( rs.next() )
            {
                ModelUserData resultdata = new ModelUserData();
                resultdata.id = rs.getString( "id" );
                resultdata.lastname = rs.getString( "lastname" );
                resultdata.firstname = rs.getString( "firstname" );
                resultdata.lastnamekana = rs.getString( "lastnamekana" );
                resultdata.firstnamekana = rs.getString( "firstnamekana" );
                resultdata.sex = rs.getInt( "sex" );
                resultdata.birthyear = rs.getInt( "birthyear" );
                resultdata.birthmonth = rs.getInt( "birthmonth" );
                resultdata.birthdate = rs.getInt( "birthdate" );
                resultdata.mailaddress = rs.getString( "mailaddress" );
                resultdata.mailaddressconfirm = resultdata.mailaddress;
                resultdata.area = rs.getInt( "area" );
                resultdata.prefecture = rs.getInt( "prefecture" );
                resultdata.schoolname = rs.getString( "schoolname" );
                resultdata.grade = rs.getInt( "grade" );
                resultdata.password = rs.getString( "password" );
                resultdata.passwordconfirm = resultdata.password;
//                System.out.println(resultdata.toString());
                result.add( resultdata );
            }

            con.close();

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            userdata.errname = "internal";
            userdata.errmessage = "G[FClassNotFoundException";
        } catch (SQLException e) {
            e.printStackTrace();
            userdata.errname = "internal";
            userdata.errmessage = "G[FSQLException";
        }

        return result;
    }

    public static boolean isExistMailaddress(String mailaddress) throws Exception {
        boolean result = false;
        try {
            Connection con = getDatabaseConnection();

            String querystring = "select * from userdata where mailaddress=?";
            PreparedStatement ps = con.prepareStatement(querystring);
            ps.setString(1, mailaddress);
//            System.out.println(ps.toString());
            ResultSet rs = ps.executeQuery();

            if ( rs.next() )
            {
                result = true;
            }

            con.close();

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return result;
    }

    public static void logging(ModelUserData userdata) {
   	    Logger log = Logger.getLogger( Database.class ); 
        log.info(userdata.toString());
    }
    
}
