package kadai1;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts2.interceptor.ServletRequestAware;

@SuppressWarnings("serial")
public class Register extends KadaiBase implements ServletRequestAware {

    public Register() {
        super();
    }
    
    private HttpServletRequest request;
    public void setServletRequest(HttpServletRequest request) {
        this.request = request;
    }

    public String execute() throws Exception {
//        System.out.println(this.getClass().getName() +".execute()");

        if ( isInvalid() ) {
            return INPUT;
        }

        return SUCCESS;
    }

    public String entry() throws Exception {
//        System.out.println(this.getClass().getName() +".entry()");
        
        if ( isInvalid() ) {
            return INPUT;
        }

        model.errname = null;
        model.remotedddr = request.getRemoteAddr();
        if("update".equals(model.entrymode)) {
            Database.updateData(model);
        } else {
            Database.insertData(model);
        }

        if (model.errname != null) {
            if (Database.isExistMailaddress(model.mailaddress)) {
//TODO:bZ[WɂB
                addFieldError("mailaddress", "o^ĂAhXłB");
                return INPUT;
            } else {
                addFieldError(model.errname, model.errmessage);
                return INPUT;
            }
        }
        
        return SUCCESS;
    }

    public boolean isInvalid() throws Exception {
        boolean result = false;
        
        /* 
         * gB
         * iSpЂ炪ȁASpJ^JiAj
        */
        model.lastname = Validator.trimBlanks(model.lastname);
        if( Validator.isInvalideName(model.lastname) ) {
            addFieldError("lastname", "SpЂ炪ȁASpJ^JiAœ͂ĂB");
            result = true;
        }

        /* 
         * gB
         * iSpЂ炪ȁASpJ^JiAj
        */
        model.firstname = Validator.trimBlanks(model.firstname);
        if( Validator.isInvalideName(model.firstname) ) {
            addFieldError("firstname", "SpЂ炪ȁASpJ^JiAœ͂ĂB");
            result = true;
        }

        /* ݂Ȏ
         * gB
         * pA啶ɕϊ
         * ip啶At@xbgj
        */
        model.lastnamekana = Validator.trimBlanks(model.lastnamekana);
        model.lastnamekana = Validator.toHarfsizeAlphabet(model.lastnamekana);
        model.lastnamekana = model.lastnamekana.toUpperCase();
        if( Validator.isInvalideYomiRoman(model.lastnamekana) ) {
            addFieldError("lastnamekana", "pAt@xbgE啶œ͂ĂB");
            result = true;
        }

        /* ݂Ȗ
         * gB
         * pA啶ɕϊ
         * ip啶At@xbgj
        */
        model.firstnamekana = Validator.trimBlanks(model.firstnamekana);
        model.firstnamekana = Validator.toHarfsizeAlphabet(model.firstnamekana);
        model.firstnamekana = model.firstnamekana.toUpperCase();
        if( Validator.isInvalideYomiRoman(model.firstnamekana) ) {
            addFieldError("firstnamekana", "pAt@xbgE啶œ͂ĂB");
            result = true;
        }

        /* [AhX
         * gB
         * gу[̃hC܂܂Ȃ
         * mFpƈv
         * o^ĂȂAhXł邱
        */
        model.mailaddress = Validator.trimBlanks(model.mailaddress);
        model.mailaddressconfirm = Validator.trimBlanks(model.mailaddressconfirm);
        if( !model.mailaddress.equals(model.mailaddressconfirm) ) {
            addFieldError("mailaddress", "2̓͗̃[AhXv܂B");
            result = true;
        }
        if( Validator.isInvalideMailDomain(model.mailaddress) ) {
            addFieldError("mailaddress", "gт̃[AhX͎g܂̂ŁAӂB");
            result = true;
        }
        if ( (!"update".equals(model.entrymode)) && Database.isExistMailaddress(model.mailaddress)) {
            addFieldError("mailaddress", "o^ĂAhXłB");
            result = true;
        }


        /* wZ
         * IvViK{ł͂Ȃj
        */
        if ( (model.schoolname == null) || (model.schoolname.isEmpty())) {
            addFieldError("schoolname", "x̂ȂA͂B");
            addFieldError("schoolname", "wZɏĂȂꍇ͓͂Kv͂܂B");
        } else {
            model.schoolname = Validator.trimBlanks(model.schoolname);
            if( Validator.isInvalideSchoolname(model.schoolname) ) {
                addFieldError("schoolname", "J^JiAЂ炪ȁAAascii󎚉\œ͂ĂB");
                result = true;
            }
        }
        
        /* pX[h
         * ippj
         * At@xbgƐ̍K{
        */
        if( !model.password.equals(model.passwordconfirm) ) {
            addFieldError("password", "2̓͗̃pX[hv܂B");
            result = true;
        }
        if( Validator.isInvalidePassword(model.password) ) {
            addFieldError("password", "pAt@xbgi啶EʁjƔpK1ȏ㍬ĂB");
            result = true;
        }

        return result;
    }

}
