package kadai1;

import java.util.regex.*;

public class Validator {

    /**
     * sEs̑Sp󔒁Ep󔒂gB
     * @param s B
     * @return gԂB
     */
    public static String trimBlanks(String s) {
        String result;
        result = s.replaceAll("^[\\s@]*", "").replaceAll("[\\s@]*$", "");
        return result;
    }
    
    /**
     * Ђ炪ȃJ^JiȊO̎킪܂܂Ă邩
     * @param s 
     * @return ̎킪܂܂ĂꍇtrueԂB
     */
    public static boolean isInvalideName(String s) {
        //u3005:X؂́X͊ł͂Ȃ炵Ał͂͂Ȃ悤ɂB
        Pattern p = Pattern.compile(
            "[^\\p{InHiragana}\\p{InKatakana}\\p{InCJKUnifiedIdeographs}\\u3005]");
        Matcher m = p.matcher(s);
        return m.find();
    }

    /**
     * SpAt@xbg𔼊pAt@xbgɕϊB
     * @param s B
     * @return ϊԂB
     */
    public static String toHarfsizeAlphabet(String s) {
        StringBuffer result = new StringBuffer();
        for (int i=0; i < s.length(); i++) {
            char c = s.charAt(i);
            if (c >= '' && c <= '') {
                c = (char) (c - '' + 'a');
            } else if (c >= '`' && c <= 'y') {
                c = (char) (c - '`' + 'A');
            }
            result.append( c );
        }
        return result.toString();
    }
    
    /**
     * At@xbgȊO̎킪܂܂Ă邩
     * @param s 
     * @return ̎킪܂܂ĂꍇtrueԂB
     */
    public static boolean isInvalideYomiRoman(String s) {
        Pattern p = Pattern.compile("[^\\p{Upper}]");
        Matcher m = p.matcher(s);
        return m.find();
    }

    static String[] mobiledomain = {
            "@docomo.ne.jp$",        // NTT hR
            "@ezweb.ne.jp$",        // KDDI au/TU-KA
            "@.*\\.ezweb.ne.jp$",    // KDDI au/TU-KA
            "@softbank.ne.jp$",        // \tgoN(Vodafone)
            "@d.vodafone.ne.jp$",    // kC
            "@h.vodafone.ne.jp$",    // k
            "@t.vodafone.ne.jp$",    // 
            "@c.vodafone.ne.jp$",    // C
            "@r.vodafone.ne.jp$",    // k
            "@k.vodafone.ne.jp$",    // ֐
            "@n.vodafone.ne.jp$",    // 
            "@s.vodafone.ne.jp$",    // l
            "@q.vodafone.ne.jp$",    // B
            "@pdx.ne.jp$",            // EBR
            "@.*\\.pdx.ne.jp$",        // EBR
            //"@willcom.com$",        // EBR
        };
    
    /**
     * gу[̃hC܂܂Ă邩
     * @param s gς݁A[AhX`؍ς݁A̕
     * @return ܂܂ĂꍇtrueԂB
     */
    public static boolean isInvalideMailDomain(String s) {
        for (int i = 0; i < mobiledomain.length; i++) {
            Pattern p = Pattern.compile( mobiledomain[i] );
            Matcher m = p.matcher(s);
            if ( m.find() ) return true;
        }
        return false;
    }

    /**
     * Ђ炪ȃJ^Jiascii󎚉\ȊO̎킪܂܂Ă邩
     * @param s 
     * @return ̎킪܂܂ĂꍇtrueԂB
     */
    public static boolean isInvalideSchoolname(String s) {
        Pattern p = Pattern.compile(
            "[^\\p{InHiragana}\\p{InKatakana}\\p{InCJKUnifiedIdeographs}\\u3005\\p{Print}]");
        Matcher m = p.matcher(s);
        return m.find();
    }

    /**
     * ppȊO̎킪܂܂Ă邩AAt@xbgƐĂ邩
     * @param s 
     * @return ̎킪܂܂ĂA܂̓At@xbgƐĂȂꍇtrueԂB
     */
    public static boolean isInvalidePassword(String s) {
        // `FbN
        {
            Pattern p = Pattern.compile("[^\\p{Alnum}]");
            Matcher m = p.matcher(s);
            if ( m.find() ) return true;
        }

        boolean alpha;
        {
            Pattern p = Pattern.compile("[^\\p{Alpha}]");
            Matcher m = p.matcher(s);
            alpha = m.find();
        }

        boolean digit;
        {
            Pattern p = Pattern.compile("[^\\p{Digit}]");
            Matcher m = p.matcher(s);
            digit = m.find();
        }
        
        return !(alpha & digit);
    }

}
